package dev.shadowsoffire.apotheosis.adventure.affix.salvaging;

import net.minecraft.world.item.TooltipFlag;
import java.util.List;
import net.minecraft.world.level.Level;
import net.minecraft.network.chat.Style;
import net.minecraft.network.chat.TextColor;
import dev.shadowsoffire.placebo.color.GradientColor;
import net.minecraft.ChatFormatting;
import net.minecraft.network.chat.Component;
import net.minecraft.world.item.ItemStack;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import net.minecraft.world.item.Item;

public class SalvageItem extends Item
{
    protected final DynamicHolder<LootRarity> rarity;
    
    public SalvageItem(final DynamicHolder<LootRarity> rarity, final Item.Properties pProperties) {
        super(pProperties);
        this.rarity = rarity;
    }
    
    public Component m_7626_(final ItemStack pStack) {
        if ("ancient".equals(this.rarity.getId().m_135815_())) {
            return (Component)Component.m_237115_(this.m_5671_(pStack)).m_130940_(ChatFormatting.OBFUSCATED).m_130938_(s -> s.m_131148_((TextColor)GradientColor.RAINBOW));
        }
        if (!this.rarity.isBound()) {
            return super.m_7626_(pStack);
        }
        return (Component)Component.m_237115_(this.m_5671_(pStack)).m_130948_(Style.f_131099_.m_131148_(((LootRarity)this.rarity.get()).getColor()));
    }
    
    public void m_7373_(final ItemStack pStack, final Level pLevel, final List<Component> list, final TooltipFlag pIsAdvanced) {
        if (this.rarity.isBound()) {
            list.add((Component)Component.m_237110_("info.apotheosis.rarity_material", new Object[] { ((LootRarity)this.rarity.get()).toComponent() }).m_130940_(ChatFormatting.GRAY));
        }
    }
}
